package org.eclipse.viatra.integration.uml.derivedfeatures;

import org.eclipse.viatra.integration.uml.derivedfeatures.ActionContextMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActionInputMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActionOutputMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActivityEdgeInGroupMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActivityGroupContainedEdgeMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActivityGroupContainedNodeMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActivityGroupInActivityMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActivityGroupMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActivityGroupSubgroupMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActivityGroupSuperGroupMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActivityNodeActivityMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActivityNodeInGroupMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ActivityNodeMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.AssociationEndTypeMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.BehaviorContextMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ClassExtensionMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ClassSuperClassMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ClassifierAttributeMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ClassifierFeatureMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ClassifierGeneralMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ConnectableElementEndMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ConnectorKindMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.DeploymentTargetDeployedElementMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.DirectedRelationshipSourceMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.DirectedRelationshipTargetMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ElementOwnedElementMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ElementOwnerMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.EncapsulatedClassifierOwnedPortMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ExtensionMetaclassMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.FeatureFeaturingClassifierMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.MessageMessageKindMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.NamedElementClientDependencyMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.NamedElementNamespaceMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.NamedElementQualifiedNameMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.NamespaceImportedMemberMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.NamespaceMemberMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.NamespaceOwnedMemberMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.OpaqueExpressionResultMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.PackageNestedPackageMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.PackageNestingPackageMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.PackageOwnedStereotypeMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.PackageOwnedTypeMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.PropertyIsCompositeMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.ProtocolTransitionReferredMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.RedefinableElementRedefinedElementMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.RedefinableElementRedefinitionContextMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.RedefinableTemplateSignatureInheritedParameterMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.RelationshipRelatedElementMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.StateIsCompositeMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.StateIsOrthogonalMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.StructuredClassifierPartMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.StructuredClassifierRoleMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.TypePackageMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.VertexIncomingMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.VertexOutgoingMatcher;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActionContextQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActionInputQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActionOutputQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActivityEdgeInGroupQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActivityGroupContainedEdgeQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActivityGroupContainedNodeQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActivityGroupInActivityQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActivityGroupQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActivityGroupSubgroupQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActivityGroupSuperGroupQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActivityNodeActivityQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActivityNodeInGroupQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ActivityNodeQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.AssociationEndTypeQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.BehaviorContextQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ClassExtensionQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ClassSuperClassQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ClassifierAttributeQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ClassifierFeatureQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ClassifierGeneralQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ConnectableElementEndQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ConnectorKindQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.DeploymentTargetDeployedElementQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.DirectedRelationshipSourceQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.DirectedRelationshipTargetQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ElementOwnedElementQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ElementOwnerQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.EncapsulatedClassifierOwnedPortQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ExtensionMetaclassQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.FeatureFeaturingClassifierQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.MessageMessageKindQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.NamedElementClientDependencyQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.NamedElementNamespaceQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.NamedElementQualifiedNameQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.NamespaceImportedMemberQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.NamespaceMemberQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.NamespaceOwnedMemberQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.OpaqueExpressionResultQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.PackageNestedPackageQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.PackageNestingPackageQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.PackageOwnedStereotypeQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.PackageOwnedTypeQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.PropertyIsCompositeQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.ProtocolTransitionReferredQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.RedefinableElementRedefinedElementQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.RedefinableElementRedefinitionContextQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.RedefinableTemplateSignatureInheritedParameterQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.RelationshipRelatedElementQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.StateIsCompositeQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.StateIsOrthogonalQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.StructuredClassifierPartQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.StructuredClassifierRoleQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.TypePackageQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.VertexIncomingQuerySpecification;
import org.eclipse.viatra.integration.uml.derivedfeatures.util.VertexOutgoingQuerySpecification;
import org.eclipse.viatra.query.runtime.api.ViatraQueryEngine;
import org.eclipse.viatra.query.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.viatra.query.runtime.exception.ViatraQueryException;

/**
 * A pattern group formed of all patterns defined in DerivedFeatures.vql.
 * 
 * <p>Use the static instance as any {@link org.eclipse.viatra.query.runtime.api.IPatternGroup}, to conveniently prepare
 * a VIATRA Query engine for matching all patterns originally defined in file DerivedFeatures.vql,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package org.eclipse.viatra.integration.uml.derivedfeatures, the group contains the definition of the following patterns: <ul>
 * <li>actionInput</li>
 * <li>actionOutput</li>
 * <li>activityGroup</li>
 * <li>activityGroupInActivity</li>
 * <li>activityNode</li>
 * <li>activityNodeActivity</li>
 * <li>activityEdgeInGroup</li>
 * <li>activityGroupContainedEdge</li>
 * <li>activityGroupContainedNode</li>
 * <li>activityNodeInGroup</li>
 * <li>activityGroupSubgroup</li>
 * <li>activityGroupSuperGroup</li>
 * <li>classifierAttribute</li>
 * <li>classifierFeature</li>
 * <li>featureFeaturingClassifier</li>
 * <li>directedRelationshipSource</li>
 * <li>directedRelationshipTarget</li>
 * <li>elementOwnedElement</li>
 * <li>elementOwner</li>
 * <li>propertyClass</li>
 * <li>namespaceMember</li>
 * <li>namespaceOwnedMember</li>
 * <li>redefinableElementRedefinedElement</li>
 * <li>redefinableElementRedefinitionContext</li>
 * <li>regionRedefinitionContext</li>
 * <li>stateRedefinitionContext</li>
 * <li>transitionRedefinitionContext</li>
 * <li>relationshipRelatedElement</li>
 * <li>structuredClassifierRole</li>
 * <li>actionContext</li>
 * <li>associationEndType</li>
 * <li>behaviorContext</li>
 * <li>internalBehaviorContext</li>
 * <li>intermediateBehaviorClassifier</li>
 * <li>nestedClassifier</li>
 * <li>connectableElementEnd</li>
 * <li>deploymentTargetDeployedElement</li>
 * <li>namedElementClientDependency</li>
 * <li>protocolTransitionReferred</li>
 * <li>vertexIncoming</li>
 * <li>vertexOutgoing</li>
 * <li>connectorKind</li>
 * <li>connectorKindDelegation</li>
 * <li>connectorEndPartWithPort</li>
 * <li>messageMessageKind</li>
 * <li>messageSendEvent</li>
 * <li>messageReceiveEvent</li>
 * <li>packageNestedPackage</li>
 * <li>packageOwnedStereotype</li>
 * <li>packageOwnedType</li>
 * <li>propertyIsComposite</li>
 * <li>stateIsComposite</li>
 * <li>stateIsComposite_0</li>
 * <li>namedElementNamespace</li>
 * <li>typePackage</li>
 * <li>classExtension</li>
 * <li>typeOrAllParents</li>
 * <li>classSuperClass</li>
 * <li>classifierAllParents</li>
 * <li>classifierGeneral</li>
 * <li>isClass</li>
 * <li>encapsulatedClassifierOwnedPort</li>
 * <li>extensionMetaclass</li>
 * <li>extensionMetaclassEnd</li>
 * <li>extensionOwnedEnd</li>
 * <li>namedElementQualifiedName</li>
 * <li>internalNamedElementNamespace</li>
 * <li>namespaceImportedMember</li>
 * <li>opaqueExpressionResult</li>
 * <li>packageVisibleMember</li>
 * <li>packageDirectlyVisibleMember</li>
 * <li>packageAllImportedPackages</li>
 * <li>packageImportedPackage</li>
 * <li>packageNestingPackage</li>
 * <li>redefinableTemplateSignatureInheritedParameter</li>
 * <li>structuredClassifierPart</li>
 * <li>stateIsOrthogonal</li>
 * <li>actionContainingBehavior</li>
 * <li>classifierParents</li>
 * <li>operationReturnResult</li>
 * <li>regionContainingStateMachine</li>
 * <li>transitionContainingStateMachine</li>
 * <li>vertexContainingStateMachine</li>
 * <li>stateMachineContainment</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class DerivedFeatures extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws ViatraQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static DerivedFeatures instance() throws ViatraQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new DerivedFeatures();
    }
    return INSTANCE;
  }
  
  private static DerivedFeatures INSTANCE;
  
  private DerivedFeatures() throws ViatraQueryException {
    querySpecifications.add(ActionInputQuerySpecification.instance());
    querySpecifications.add(ActionOutputQuerySpecification.instance());
    querySpecifications.add(ActivityGroupQuerySpecification.instance());
    querySpecifications.add(ActivityGroupInActivityQuerySpecification.instance());
    querySpecifications.add(ActivityNodeQuerySpecification.instance());
    querySpecifications.add(ActivityNodeActivityQuerySpecification.instance());
    querySpecifications.add(ActivityEdgeInGroupQuerySpecification.instance());
    querySpecifications.add(ActivityGroupContainedEdgeQuerySpecification.instance());
    querySpecifications.add(ActivityGroupContainedNodeQuerySpecification.instance());
    querySpecifications.add(ActivityNodeInGroupQuerySpecification.instance());
    querySpecifications.add(ActivityGroupSubgroupQuerySpecification.instance());
    querySpecifications.add(ActivityGroupSuperGroupQuerySpecification.instance());
    querySpecifications.add(ClassifierAttributeQuerySpecification.instance());
    querySpecifications.add(ClassifierFeatureQuerySpecification.instance());
    querySpecifications.add(FeatureFeaturingClassifierQuerySpecification.instance());
    querySpecifications.add(DirectedRelationshipSourceQuerySpecification.instance());
    querySpecifications.add(DirectedRelationshipTargetQuerySpecification.instance());
    querySpecifications.add(ElementOwnedElementQuerySpecification.instance());
    querySpecifications.add(ElementOwnerQuerySpecification.instance());
    querySpecifications.add(NamespaceMemberQuerySpecification.instance());
    querySpecifications.add(NamespaceOwnedMemberQuerySpecification.instance());
    querySpecifications.add(RedefinableElementRedefinedElementQuerySpecification.instance());
    querySpecifications.add(RedefinableElementRedefinitionContextQuerySpecification.instance());
    querySpecifications.add(RelationshipRelatedElementQuerySpecification.instance());
    querySpecifications.add(StructuredClassifierRoleQuerySpecification.instance());
    querySpecifications.add(ActionContextQuerySpecification.instance());
    querySpecifications.add(AssociationEndTypeQuerySpecification.instance());
    querySpecifications.add(BehaviorContextQuerySpecification.instance());
    querySpecifications.add(ConnectableElementEndQuerySpecification.instance());
    querySpecifications.add(DeploymentTargetDeployedElementQuerySpecification.instance());
    querySpecifications.add(NamedElementClientDependencyQuerySpecification.instance());
    querySpecifications.add(ProtocolTransitionReferredQuerySpecification.instance());
    querySpecifications.add(VertexIncomingQuerySpecification.instance());
    querySpecifications.add(VertexOutgoingQuerySpecification.instance());
    querySpecifications.add(ConnectorKindQuerySpecification.instance());
    querySpecifications.add(MessageMessageKindQuerySpecification.instance());
    querySpecifications.add(PackageNestedPackageQuerySpecification.instance());
    querySpecifications.add(PackageOwnedStereotypeQuerySpecification.instance());
    querySpecifications.add(PackageOwnedTypeQuerySpecification.instance());
    querySpecifications.add(PropertyIsCompositeQuerySpecification.instance());
    querySpecifications.add(StateIsCompositeQuerySpecification.instance());
    querySpecifications.add(NamedElementNamespaceQuerySpecification.instance());
    querySpecifications.add(TypePackageQuerySpecification.instance());
    querySpecifications.add(ClassExtensionQuerySpecification.instance());
    querySpecifications.add(ClassSuperClassQuerySpecification.instance());
    querySpecifications.add(ClassifierGeneralQuerySpecification.instance());
    querySpecifications.add(EncapsulatedClassifierOwnedPortQuerySpecification.instance());
    querySpecifications.add(ExtensionMetaclassQuerySpecification.instance());
    querySpecifications.add(NamedElementQualifiedNameQuerySpecification.instance());
    querySpecifications.add(NamespaceImportedMemberQuerySpecification.instance());
    querySpecifications.add(OpaqueExpressionResultQuerySpecification.instance());
    querySpecifications.add(PackageNestingPackageQuerySpecification.instance());
    querySpecifications.add(RedefinableTemplateSignatureInheritedParameterQuerySpecification.instance());
    querySpecifications.add(StructuredClassifierPartQuerySpecification.instance());
    querySpecifications.add(StateIsOrthogonalQuerySpecification.instance());
  }
  
  public ActionInputQuerySpecification getActionInput() throws ViatraQueryException {
    return ActionInputQuerySpecification.instance();
  }
  
  public ActionInputMatcher getActionInput(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActionInputMatcher.on(engine);
  }
  
  public ActionOutputQuerySpecification getActionOutput() throws ViatraQueryException {
    return ActionOutputQuerySpecification.instance();
  }
  
  public ActionOutputMatcher getActionOutput(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActionOutputMatcher.on(engine);
  }
  
  public ActivityGroupQuerySpecification getActivityGroup() throws ViatraQueryException {
    return ActivityGroupQuerySpecification.instance();
  }
  
  public ActivityGroupMatcher getActivityGroup(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActivityGroupMatcher.on(engine);
  }
  
  public ActivityGroupInActivityQuerySpecification getActivityGroupInActivity() throws ViatraQueryException {
    return ActivityGroupInActivityQuerySpecification.instance();
  }
  
  public ActivityGroupInActivityMatcher getActivityGroupInActivity(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActivityGroupInActivityMatcher.on(engine);
  }
  
  public ActivityNodeQuerySpecification getActivityNode() throws ViatraQueryException {
    return ActivityNodeQuerySpecification.instance();
  }
  
  public ActivityNodeMatcher getActivityNode(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActivityNodeMatcher.on(engine);
  }
  
  public ActivityNodeActivityQuerySpecification getActivityNodeActivity() throws ViatraQueryException {
    return ActivityNodeActivityQuerySpecification.instance();
  }
  
  public ActivityNodeActivityMatcher getActivityNodeActivity(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActivityNodeActivityMatcher.on(engine);
  }
  
  public ActivityEdgeInGroupQuerySpecification getActivityEdgeInGroup() throws ViatraQueryException {
    return ActivityEdgeInGroupQuerySpecification.instance();
  }
  
  public ActivityEdgeInGroupMatcher getActivityEdgeInGroup(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActivityEdgeInGroupMatcher.on(engine);
  }
  
  public ActivityGroupContainedEdgeQuerySpecification getActivityGroupContainedEdge() throws ViatraQueryException {
    return ActivityGroupContainedEdgeQuerySpecification.instance();
  }
  
  public ActivityGroupContainedEdgeMatcher getActivityGroupContainedEdge(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActivityGroupContainedEdgeMatcher.on(engine);
  }
  
  public ActivityGroupContainedNodeQuerySpecification getActivityGroupContainedNode() throws ViatraQueryException {
    return ActivityGroupContainedNodeQuerySpecification.instance();
  }
  
  public ActivityGroupContainedNodeMatcher getActivityGroupContainedNode(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActivityGroupContainedNodeMatcher.on(engine);
  }
  
  public ActivityNodeInGroupQuerySpecification getActivityNodeInGroup() throws ViatraQueryException {
    return ActivityNodeInGroupQuerySpecification.instance();
  }
  
  public ActivityNodeInGroupMatcher getActivityNodeInGroup(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActivityNodeInGroupMatcher.on(engine);
  }
  
  public ActivityGroupSubgroupQuerySpecification getActivityGroupSubgroup() throws ViatraQueryException {
    return ActivityGroupSubgroupQuerySpecification.instance();
  }
  
  public ActivityGroupSubgroupMatcher getActivityGroupSubgroup(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActivityGroupSubgroupMatcher.on(engine);
  }
  
  public ActivityGroupSuperGroupQuerySpecification getActivityGroupSuperGroup() throws ViatraQueryException {
    return ActivityGroupSuperGroupQuerySpecification.instance();
  }
  
  public ActivityGroupSuperGroupMatcher getActivityGroupSuperGroup(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActivityGroupSuperGroupMatcher.on(engine);
  }
  
  public ClassifierAttributeQuerySpecification getClassifierAttribute() throws ViatraQueryException {
    return ClassifierAttributeQuerySpecification.instance();
  }
  
  public ClassifierAttributeMatcher getClassifierAttribute(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ClassifierAttributeMatcher.on(engine);
  }
  
  public ClassifierFeatureQuerySpecification getClassifierFeature() throws ViatraQueryException {
    return ClassifierFeatureQuerySpecification.instance();
  }
  
  public ClassifierFeatureMatcher getClassifierFeature(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ClassifierFeatureMatcher.on(engine);
  }
  
  public FeatureFeaturingClassifierQuerySpecification getFeatureFeaturingClassifier() throws ViatraQueryException {
    return FeatureFeaturingClassifierQuerySpecification.instance();
  }
  
  public FeatureFeaturingClassifierMatcher getFeatureFeaturingClassifier(final ViatraQueryEngine engine) throws ViatraQueryException {
    return FeatureFeaturingClassifierMatcher.on(engine);
  }
  
  public DirectedRelationshipSourceQuerySpecification getDirectedRelationshipSource() throws ViatraQueryException {
    return DirectedRelationshipSourceQuerySpecification.instance();
  }
  
  public DirectedRelationshipSourceMatcher getDirectedRelationshipSource(final ViatraQueryEngine engine) throws ViatraQueryException {
    return DirectedRelationshipSourceMatcher.on(engine);
  }
  
  public DirectedRelationshipTargetQuerySpecification getDirectedRelationshipTarget() throws ViatraQueryException {
    return DirectedRelationshipTargetQuerySpecification.instance();
  }
  
  public DirectedRelationshipTargetMatcher getDirectedRelationshipTarget(final ViatraQueryEngine engine) throws ViatraQueryException {
    return DirectedRelationshipTargetMatcher.on(engine);
  }
  
  public ElementOwnedElementQuerySpecification getElementOwnedElement() throws ViatraQueryException {
    return ElementOwnedElementQuerySpecification.instance();
  }
  
  public ElementOwnedElementMatcher getElementOwnedElement(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ElementOwnedElementMatcher.on(engine);
  }
  
  public ElementOwnerQuerySpecification getElementOwner() throws ViatraQueryException {
    return ElementOwnerQuerySpecification.instance();
  }
  
  public ElementOwnerMatcher getElementOwner(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ElementOwnerMatcher.on(engine);
  }
  
  public NamespaceMemberQuerySpecification getNamespaceMember() throws ViatraQueryException {
    return NamespaceMemberQuerySpecification.instance();
  }
  
  public NamespaceMemberMatcher getNamespaceMember(final ViatraQueryEngine engine) throws ViatraQueryException {
    return NamespaceMemberMatcher.on(engine);
  }
  
  public NamespaceOwnedMemberQuerySpecification getNamespaceOwnedMember() throws ViatraQueryException {
    return NamespaceOwnedMemberQuerySpecification.instance();
  }
  
  public NamespaceOwnedMemberMatcher getNamespaceOwnedMember(final ViatraQueryEngine engine) throws ViatraQueryException {
    return NamespaceOwnedMemberMatcher.on(engine);
  }
  
  public RedefinableElementRedefinedElementQuerySpecification getRedefinableElementRedefinedElement() throws ViatraQueryException {
    return RedefinableElementRedefinedElementQuerySpecification.instance();
  }
  
  public RedefinableElementRedefinedElementMatcher getRedefinableElementRedefinedElement(final ViatraQueryEngine engine) throws ViatraQueryException {
    return RedefinableElementRedefinedElementMatcher.on(engine);
  }
  
  public RedefinableElementRedefinitionContextQuerySpecification getRedefinableElementRedefinitionContext() throws ViatraQueryException {
    return RedefinableElementRedefinitionContextQuerySpecification.instance();
  }
  
  public RedefinableElementRedefinitionContextMatcher getRedefinableElementRedefinitionContext(final ViatraQueryEngine engine) throws ViatraQueryException {
    return RedefinableElementRedefinitionContextMatcher.on(engine);
  }
  
  public RelationshipRelatedElementQuerySpecification getRelationshipRelatedElement() throws ViatraQueryException {
    return RelationshipRelatedElementQuerySpecification.instance();
  }
  
  public RelationshipRelatedElementMatcher getRelationshipRelatedElement(final ViatraQueryEngine engine) throws ViatraQueryException {
    return RelationshipRelatedElementMatcher.on(engine);
  }
  
  public StructuredClassifierRoleQuerySpecification getStructuredClassifierRole() throws ViatraQueryException {
    return StructuredClassifierRoleQuerySpecification.instance();
  }
  
  public StructuredClassifierRoleMatcher getStructuredClassifierRole(final ViatraQueryEngine engine) throws ViatraQueryException {
    return StructuredClassifierRoleMatcher.on(engine);
  }
  
  public ActionContextQuerySpecification getActionContext() throws ViatraQueryException {
    return ActionContextQuerySpecification.instance();
  }
  
  public ActionContextMatcher getActionContext(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ActionContextMatcher.on(engine);
  }
  
  public AssociationEndTypeQuerySpecification getAssociationEndType() throws ViatraQueryException {
    return AssociationEndTypeQuerySpecification.instance();
  }
  
  public AssociationEndTypeMatcher getAssociationEndType(final ViatraQueryEngine engine) throws ViatraQueryException {
    return AssociationEndTypeMatcher.on(engine);
  }
  
  public BehaviorContextQuerySpecification getBehaviorContext() throws ViatraQueryException {
    return BehaviorContextQuerySpecification.instance();
  }
  
  public BehaviorContextMatcher getBehaviorContext(final ViatraQueryEngine engine) throws ViatraQueryException {
    return BehaviorContextMatcher.on(engine);
  }
  
  public ConnectableElementEndQuerySpecification getConnectableElementEnd() throws ViatraQueryException {
    return ConnectableElementEndQuerySpecification.instance();
  }
  
  public ConnectableElementEndMatcher getConnectableElementEnd(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ConnectableElementEndMatcher.on(engine);
  }
  
  public DeploymentTargetDeployedElementQuerySpecification getDeploymentTargetDeployedElement() throws ViatraQueryException {
    return DeploymentTargetDeployedElementQuerySpecification.instance();
  }
  
  public DeploymentTargetDeployedElementMatcher getDeploymentTargetDeployedElement(final ViatraQueryEngine engine) throws ViatraQueryException {
    return DeploymentTargetDeployedElementMatcher.on(engine);
  }
  
  public NamedElementClientDependencyQuerySpecification getNamedElementClientDependency() throws ViatraQueryException {
    return NamedElementClientDependencyQuerySpecification.instance();
  }
  
  public NamedElementClientDependencyMatcher getNamedElementClientDependency(final ViatraQueryEngine engine) throws ViatraQueryException {
    return NamedElementClientDependencyMatcher.on(engine);
  }
  
  public ProtocolTransitionReferredQuerySpecification getProtocolTransitionReferred() throws ViatraQueryException {
    return ProtocolTransitionReferredQuerySpecification.instance();
  }
  
  public ProtocolTransitionReferredMatcher getProtocolTransitionReferred(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ProtocolTransitionReferredMatcher.on(engine);
  }
  
  public VertexIncomingQuerySpecification getVertexIncoming() throws ViatraQueryException {
    return VertexIncomingQuerySpecification.instance();
  }
  
  public VertexIncomingMatcher getVertexIncoming(final ViatraQueryEngine engine) throws ViatraQueryException {
    return VertexIncomingMatcher.on(engine);
  }
  
  public VertexOutgoingQuerySpecification getVertexOutgoing() throws ViatraQueryException {
    return VertexOutgoingQuerySpecification.instance();
  }
  
  public VertexOutgoingMatcher getVertexOutgoing(final ViatraQueryEngine engine) throws ViatraQueryException {
    return VertexOutgoingMatcher.on(engine);
  }
  
  public ConnectorKindQuerySpecification getConnectorKind() throws ViatraQueryException {
    return ConnectorKindQuerySpecification.instance();
  }
  
  public ConnectorKindMatcher getConnectorKind(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ConnectorKindMatcher.on(engine);
  }
  
  public MessageMessageKindQuerySpecification getMessageMessageKind() throws ViatraQueryException {
    return MessageMessageKindQuerySpecification.instance();
  }
  
  public MessageMessageKindMatcher getMessageMessageKind(final ViatraQueryEngine engine) throws ViatraQueryException {
    return MessageMessageKindMatcher.on(engine);
  }
  
  public PackageNestedPackageQuerySpecification getPackageNestedPackage() throws ViatraQueryException {
    return PackageNestedPackageQuerySpecification.instance();
  }
  
  public PackageNestedPackageMatcher getPackageNestedPackage(final ViatraQueryEngine engine) throws ViatraQueryException {
    return PackageNestedPackageMatcher.on(engine);
  }
  
  public PackageOwnedStereotypeQuerySpecification getPackageOwnedStereotype() throws ViatraQueryException {
    return PackageOwnedStereotypeQuerySpecification.instance();
  }
  
  public PackageOwnedStereotypeMatcher getPackageOwnedStereotype(final ViatraQueryEngine engine) throws ViatraQueryException {
    return PackageOwnedStereotypeMatcher.on(engine);
  }
  
  public PackageOwnedTypeQuerySpecification getPackageOwnedType() throws ViatraQueryException {
    return PackageOwnedTypeQuerySpecification.instance();
  }
  
  public PackageOwnedTypeMatcher getPackageOwnedType(final ViatraQueryEngine engine) throws ViatraQueryException {
    return PackageOwnedTypeMatcher.on(engine);
  }
  
  public PropertyIsCompositeQuerySpecification getPropertyIsComposite() throws ViatraQueryException {
    return PropertyIsCompositeQuerySpecification.instance();
  }
  
  public PropertyIsCompositeMatcher getPropertyIsComposite(final ViatraQueryEngine engine) throws ViatraQueryException {
    return PropertyIsCompositeMatcher.on(engine);
  }
  
  public StateIsCompositeQuerySpecification getStateIsComposite() throws ViatraQueryException {
    return StateIsCompositeQuerySpecification.instance();
  }
  
  public StateIsCompositeMatcher getStateIsComposite(final ViatraQueryEngine engine) throws ViatraQueryException {
    return StateIsCompositeMatcher.on(engine);
  }
  
  public NamedElementNamespaceQuerySpecification getNamedElementNamespace() throws ViatraQueryException {
    return NamedElementNamespaceQuerySpecification.instance();
  }
  
  public NamedElementNamespaceMatcher getNamedElementNamespace(final ViatraQueryEngine engine) throws ViatraQueryException {
    return NamedElementNamespaceMatcher.on(engine);
  }
  
  public TypePackageQuerySpecification getTypePackage() throws ViatraQueryException {
    return TypePackageQuerySpecification.instance();
  }
  
  public TypePackageMatcher getTypePackage(final ViatraQueryEngine engine) throws ViatraQueryException {
    return TypePackageMatcher.on(engine);
  }
  
  public ClassExtensionQuerySpecification getClassExtension() throws ViatraQueryException {
    return ClassExtensionQuerySpecification.instance();
  }
  
  public ClassExtensionMatcher getClassExtension(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ClassExtensionMatcher.on(engine);
  }
  
  public ClassSuperClassQuerySpecification getClassSuperClass() throws ViatraQueryException {
    return ClassSuperClassQuerySpecification.instance();
  }
  
  public ClassSuperClassMatcher getClassSuperClass(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ClassSuperClassMatcher.on(engine);
  }
  
  public ClassifierGeneralQuerySpecification getClassifierGeneral() throws ViatraQueryException {
    return ClassifierGeneralQuerySpecification.instance();
  }
  
  public ClassifierGeneralMatcher getClassifierGeneral(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ClassifierGeneralMatcher.on(engine);
  }
  
  public EncapsulatedClassifierOwnedPortQuerySpecification getEncapsulatedClassifierOwnedPort() throws ViatraQueryException {
    return EncapsulatedClassifierOwnedPortQuerySpecification.instance();
  }
  
  public EncapsulatedClassifierOwnedPortMatcher getEncapsulatedClassifierOwnedPort(final ViatraQueryEngine engine) throws ViatraQueryException {
    return EncapsulatedClassifierOwnedPortMatcher.on(engine);
  }
  
  public ExtensionMetaclassQuerySpecification getExtensionMetaclass() throws ViatraQueryException {
    return ExtensionMetaclassQuerySpecification.instance();
  }
  
  public ExtensionMetaclassMatcher getExtensionMetaclass(final ViatraQueryEngine engine) throws ViatraQueryException {
    return ExtensionMetaclassMatcher.on(engine);
  }
  
  public NamedElementQualifiedNameQuerySpecification getNamedElementQualifiedName() throws ViatraQueryException {
    return NamedElementQualifiedNameQuerySpecification.instance();
  }
  
  public NamedElementQualifiedNameMatcher getNamedElementQualifiedName(final ViatraQueryEngine engine) throws ViatraQueryException {
    return NamedElementQualifiedNameMatcher.on(engine);
  }
  
  public NamespaceImportedMemberQuerySpecification getNamespaceImportedMember() throws ViatraQueryException {
    return NamespaceImportedMemberQuerySpecification.instance();
  }
  
  public NamespaceImportedMemberMatcher getNamespaceImportedMember(final ViatraQueryEngine engine) throws ViatraQueryException {
    return NamespaceImportedMemberMatcher.on(engine);
  }
  
  public OpaqueExpressionResultQuerySpecification getOpaqueExpressionResult() throws ViatraQueryException {
    return OpaqueExpressionResultQuerySpecification.instance();
  }
  
  public OpaqueExpressionResultMatcher getOpaqueExpressionResult(final ViatraQueryEngine engine) throws ViatraQueryException {
    return OpaqueExpressionResultMatcher.on(engine);
  }
  
  public PackageNestingPackageQuerySpecification getPackageNestingPackage() throws ViatraQueryException {
    return PackageNestingPackageQuerySpecification.instance();
  }
  
  public PackageNestingPackageMatcher getPackageNestingPackage(final ViatraQueryEngine engine) throws ViatraQueryException {
    return PackageNestingPackageMatcher.on(engine);
  }
  
  public RedefinableTemplateSignatureInheritedParameterQuerySpecification getRedefinableTemplateSignatureInheritedParameter() throws ViatraQueryException {
    return RedefinableTemplateSignatureInheritedParameterQuerySpecification.instance();
  }
  
  public RedefinableTemplateSignatureInheritedParameterMatcher getRedefinableTemplateSignatureInheritedParameter(final ViatraQueryEngine engine) throws ViatraQueryException {
    return RedefinableTemplateSignatureInheritedParameterMatcher.on(engine);
  }
  
  public StructuredClassifierPartQuerySpecification getStructuredClassifierPart() throws ViatraQueryException {
    return StructuredClassifierPartQuerySpecification.instance();
  }
  
  public StructuredClassifierPartMatcher getStructuredClassifierPart(final ViatraQueryEngine engine) throws ViatraQueryException {
    return StructuredClassifierPartMatcher.on(engine);
  }
  
  public StateIsOrthogonalQuerySpecification getStateIsOrthogonal() throws ViatraQueryException {
    return StateIsOrthogonalQuerySpecification.instance();
  }
  
  public StateIsOrthogonalMatcher getStateIsOrthogonal(final ViatraQueryEngine engine) throws ViatraQueryException {
    return StateIsOrthogonalMatcher.on(engine);
  }
}
