package org.eclipse.viatra.integration.uml.derivedfeatures.util;

import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Feature;
import org.eclipse.viatra.integration.uml.derivedfeatures.FeatureFeaturingClassifierMatch;
import org.eclipse.viatra.query.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the org.eclipse.viatra.integration.uml.derivedfeatures.featureFeaturingClassifier pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class FeatureFeaturingClassifierProcessor implements IMatchProcessor<FeatureFeaturingClassifierMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSource the value of pattern parameter source in the currently processed match
   * @param pTarget the value of pattern parameter target in the currently processed match
   * 
   */
  public abstract void process(final Feature pSource, final Classifier pTarget);
  
  @Override
  public void process(final FeatureFeaturingClassifierMatch match) {
    process(match.getSource(), match.getTarget());
  }
}
