package org.eclipse.viatra.integration.uml.derivedfeatures.util;

import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Namespace;
import org.eclipse.viatra.integration.uml.derivedfeatures.NamedElementNamespaceMatch;
import org.eclipse.viatra.query.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the org.eclipse.viatra.integration.uml.derivedfeatures.namedElementNamespace pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class NamedElementNamespaceProcessor implements IMatchProcessor<NamedElementNamespaceMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSource the value of pattern parameter source in the currently processed match
   * @param pTarget the value of pattern parameter target in the currently processed match
   * 
   */
  public abstract void process(final NamedElement pSource, final Namespace pTarget);
  
  @Override
  public void process(final NamedElementNamespaceMatch match) {
    process(match.getSource(), match.getTarget());
  }
}
