package org.eclipse.viatra.integration.uml.derivedfeatures.util;

import org.eclipse.uml2.uml.Property;
import org.eclipse.viatra.integration.uml.derivedfeatures.PropertyIsCompositeMatch;
import org.eclipse.viatra.query.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the org.eclipse.viatra.integration.uml.derivedfeatures.propertyIsComposite pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class PropertyIsCompositeProcessor implements IMatchProcessor<PropertyIsCompositeMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pProperty the value of pattern parameter property in the currently processed match
   * @param pIsComposite the value of pattern parameter isComposite in the currently processed match
   * 
   */
  public abstract void process(final Property pProperty, final Boolean pIsComposite);
  
  @Override
  public void process(final PropertyIsCompositeMatch match) {
    process(match.getProperty(), match.getIsComposite());
  }
}
