package org.eclipse.viatra.integration.uml.derivedfeatures.util;

import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.StructuredClassifier;
import org.eclipse.viatra.integration.uml.derivedfeatures.StructuredClassifierPartMatch;
import org.eclipse.viatra.query.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the org.eclipse.viatra.integration.uml.derivedfeatures.structuredClassifierPart pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class StructuredClassifierPartProcessor implements IMatchProcessor<StructuredClassifierPartMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pStructuredClassifier the value of pattern parameter structuredClassifier in the currently processed match
   * @param pPart the value of pattern parameter part in the currently processed match
   * 
   */
  public abstract void process(final StructuredClassifier pStructuredClassifier, final Property pPart);
  
  @Override
  public void process(final StructuredClassifierPartMatch match) {
    process(match.getStructuredClassifier(), match.getPart());
  }
}
