package org.eclipse.viatra.query.tooling.ui.retevis.util;

import org.eclipse.viatra.query.runtime.api.IMatchProcessor;
import org.eclipse.viatra.query.runtime.rete.recipes.ReteNodeRecipe;
import org.eclipse.viatra.query.runtime.rete.recipes.SingleParentNodeRecipe;
import org.eclipse.viatra.query.tooling.ui.retevis.SingleParentNodeRecipeParentMatch;

/**
 * A match processor tailored for the org.eclipse.viatra.query.tooling.ui.retevis.singleParentNodeRecipeParent pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class SingleParentNodeRecipeParentProcessor implements IMatchProcessor<SingleParentNodeRecipeParentMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pRecipe the value of pattern parameter recipe in the currently processed match
   * @param pParent the value of pattern parameter parent in the currently processed match
   * 
   */
  public abstract void process(final SingleParentNodeRecipe pRecipe, final ReteNodeRecipe pParent);
  
  @Override
  public void process(final SingleParentNodeRecipeParentMatch match) {
    process(match.getRecipe(), match.getParent());
  }
}
